import axios from 'axios'
import { Notification, MessageBox, Message, Loading } from 'element-ui'
import store from '@/store'
import { getToken } from '@/utils/auth'
import errorCode from '@/utils/errorCode'
import { tansParams, blobValidate } from '@/utils/bonus'
import cache from '@/plugins/cache'
import { saveAs } from 'file-saver'
import { decryptWithSM4, encryptWithSM4, hashWithSM3AndSalt } from '@/utils/sm'
import router from '@/router'

const systemConfig = JSON.parse(localStorage.getItem('systemConfig')) || {
  requestConfig: { encryptRequest: true, checkIntegrity: true, encryptResponse: true }
};

let downloadLoadingInstance
// 是否显示重新登录
export let isRelogin = { show: false }

axios.defaults.headers['Content-Type'] = 'application/json;charset=utf-8'

// 创建axios实例
const service = axios.create({
  // axios中请求配置有baseURL选项，表示请求URL公共部分
  baseURL: process.env.VUE_APP_BASE_API,
  // 超时
  timeout: 720000
})

// request 拦截器
service.interceptors.request.use(config => {
  // 提取 headers 和方法
  const headers = config.headers || {}
  const {
    isToken = true,
    encryptRequest = process.env.NODE_ENV === 'development' ? false : true,
    checkIntegrity = process.env.NODE_ENV === 'development' ? false : true,
    encryptResponse = process.env.NODE_ENV === 'development' ? false : true,
    repeatSubmit = false
  } = headers

  // 设置请求头
  //入参加密
  config.headers['encryptRequest'] = systemConfig.requestConfig.encryptRequest && encryptRequest ? 'true' : 'false'
  // 数据完整性校验
  config.headers['checkIntegrity'] = systemConfig.requestConfig.checkIntegrity && checkIntegrity ? 'true' : 'false'
  //回参是否加密
  config.headers['encryptResponse'] = systemConfig.requestConfig.encryptResponse && encryptResponse ? 'true' : 'false'

  const isRepeatSubmit = repeatSubmit
  // 处理 Token
  if (getToken() && isToken) {
    config.headers['Authorization'] = 'Bearer ' + getToken() // 让每个请求携带自定义 token
  }

  // get请求映射params参数
  if (config.method === 'get' && config.params) {
    let url = config.url + '?' + tansParams(config.params);
    url = url.slice(0, -1);
    config.params = {};
    config.url = url;
  }

  if (!isRepeatSubmit && (config.method === 'post' || config.method === 'put')) {
    let data = typeof config.data === 'object' ? JSON.stringify(config.data) : config.data
    let contentType = config.headers['Content-Type']
    if (contentType.includes('application/json') && typeof data !== 'undefined') {
      // 加密数据
      if (systemConfig.requestConfig.encryptRequest && encryptRequest) {
        console.log(data);
        console.log(hashWithSM3AndSalt(data));
        config.data = encryptWithSM4(data+"|"+hashWithSM3AndSalt(data))
      }
    }
    // 检查请求数据大小
    const requestSize = JSON.stringify({ url: config.url, data: data, time: Date.now() }).length
    const limitSize = 1000 * 1024 * 1024 // 限制存放数据 5MB

    if (requestSize >= limitSize) {
      console.warn(`[${config.url}]: 请求数据大小超出允许的5MB限制，无法进行防重复提交验证。`)
      return config
    }
    // 防止重复提交
    const sessionObj = cache.session.getJSON('sessionObj') || {}
    const requestObj = { url: config.url, data: data, time: Date.now() }

    if (sessionObj.data === requestObj.data && requestObj.time - sessionObj.time < 0 && sessionObj.url === requestObj.url) {
      console.warn(`[${sessionObj.url}]: 数据正在处理，请勿重复提交`)
      return Promise.reject(new Error('数据正在处理，请勿重复提交'))
    }
    cache.session.setJSON('sessionObj', requestObj)
  }
  return config
}, error => {
  console.error(error)
  return Promise.reject(error)
})

// 响应拦截器
service.interceptors.response.use(res => {
    if (res.headers.encryptresponse && !res.data.hasOwnProperty('code')) {
      res.data = JSON.parse(decryptWithSM4(res.data))
    }
    // 未设置状态码则默认成功状态
    const code = res.data.code || 200
    // 获取错误信息
    const msg = errorCode[code] || res.data.msg || errorCode['default']
    // 二进制数据则直接返回
    if (res.request.responseType === 'blob' || res.request.responseType === 'arraybuffer') {
      return res.data
    }
    if (code === 401) {
      console.log('🚀 ~ process.env.VUE_APP_BASE_API:', process.env.VUE_APP_BASE_API)
      if (process.env.VUE_APP_BASE_API == '/iws/jiju-api') {
        store.dispatch('LogOut').then(() => {
        }).catch((err) => {
          console.log('🚀 ~ store.dispatch ~ err:', err)
        })
        setTimeout(() => {
          //   'http://sgwpdm.ah.sgcc.com.cn/iws/cas/login?appId=3874dcb953f184dc75450e33d6d6d4fa&service=http://sgwpdm.ah.sgcc.com.cn/iws/mea-view/',
          window.location.replace(
            'http://sgwpdm.ah.sgcc.com.cn/iws/'
          )
        }, 500)
      } else {
        store.dispatch('LogOut').then(() => {
          // location.href = '/login'
          router.push('/login')
        }).catch(() => {
          router.push('/login')
        })
      }
      sessionStorage.removeItem('idCard')
      sessionStorage.removeItem('TimestampKey')
      sessionStorage.removeItem('data')
      sessionStorage.removeItem('deptName')
      sessionStorage.removeItem('systemType')
      sessionStorage.removeItem('userId')
      sessionStorage.removeItem('userName')
      return Promise.reject('无效的会话，或者会话已过期，请重新登录。')
    } else if (code === 500) {
      Message({ message: msg, type: 'error' })
      return Promise.reject(new Error(msg))
    } else if (code === 601) {
      Message({ message: msg, type: 'warning' })
      return Promise.reject('error')
    } else if (code !== 200) {
      Notification.error({ title: msg })
      return Promise.reject('error')
    } else {
      return res.data
    }
  },
  error => {
    let { message } = error
    if (message == 'Network Error') {
      message = '后端接口连接异常'
    } else if (message.includes('timeout')) {
      message = '系统接口请求超时'
    } else if (message.includes('Request failed with status code')) {
      message = '系统接口' + message.substr(message.length - 3) + '异常'
    }
    Message({ message: message, type: 'error', duration: 5 * 1000 })
    return Promise.reject(error)
  }
)

// 通用下载方法
export function download(url, params, filename, config) {
  downloadLoadingInstance = Loading.service({
    text: '正在下载数据，请稍候',
    spinner: 'el-icon-loading',
    background: 'rgba(0, 0, 0, 0.7)'
  })
  return service.post(url, params, {
    transformRequest: [(params) => {
      return tansParams(params)
    }],
    headers: { 'Content-Type': 'application/x-www-form-urlencoded', encryptResponse: false},
    responseType: 'blob',
    ...config
  }).then(async(data) => {
    const isBlob = blobValidate(data)
    if (isBlob) {
      const blob = new Blob([data])
      saveAs(blob, filename)
    } else {
      const resText = await data.text()
      const rspObj = JSON.parse(resText)
      const errMsg = errorCode[rspObj.code] || rspObj.msg || errorCode['default']
      Message.error(errMsg)
    }
    downloadLoadingInstance.close()
  }).catch((r) => {
    console.error(r)
    Message.error('下载文件出现错误，请联系管理员！')
    downloadLoadingInstance.close()
  })
}

// 通用下载方法
export function downloadJson(url, params, filename, config) {
  downloadLoadingInstance = Loading.service({ text: "正在下载数据，请稍候", spinner: "el-icon-loading", background: "rgba(0, 0, 0, 0.7)", })
  return service.post(url, params, {
    transformRequest: [(params) => { return params }],
    headers: { 'Content-Type': 'application/json' },
    responseType: 'blob',
    ...config
  }).then(async (data) => {
    const isBlob = blobValidate(data);
    if (isBlob) {
      const blob = new Blob([data])
      saveAs(blob, filename)
    } else {
      const resText = await data.text();
      const rspObj = JSON.parse(resText);
      const errMsg = errorCode[rspObj.code] || rspObj.msg || errorCode['default']
      Message.error(errMsg);
    }
    downloadLoadingInstance.close();
  }).catch((r) => {
    console.error(r)
    Message.error('下载文件出现错误，请联系管理员！')
    downloadLoadingInstance.close();
  })
}


// 通用下载方法
export function downloadZip(url, params, filename, config) {
  // downloadLoadingInstance = Loading.service({
  //     text: '正在下载数据，请稍候',
  //     spinner: 'el-icon-loading',
  //     background: 'rgba(0, 0, 0, 0.7)',
  // })
  return service
      .post(url, params, {
          transformRequest: [
              (params) => {
                  return params
              },
          ],
          headers: { 'Content-Type': 'application/json', encryptResponse: false },
          responseType: 'blob',
          // 支持传入onDownloadProgress回调
          ...(config && config.onDownloadProgress ? { onDownloadProgress: config.onDownloadProgress } : {}),
          ...config,
      })
      .then(async (data) => {
          const isBlob = blobValidate(data)
          if (isBlob) {
              const blob = new Blob([data])
              saveAs(blob, filename)
          } else {
              const resText = await data.text()
              const rspObj = JSON.parse(resText)
              const errMsg =
                  errorCode[rspObj.code] || rspObj.msg || errorCode['default']
              Message.error(errMsg)
          }
          // downloadLoadingInstance.close()
      })
      .catch((r) => {
          console.error(r)
          Message.error('下载文件出现错误，请联系管理员！')
          // downloadLoadingInstance.close()
      })
 }
export default service
